//+------------------------------------------------------------------+
//|                                             criss_cross_v101.mq4 |
//|                                                         azman818 |
//|                                                          criss73 |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

//---- input parameters

extern int     levels=8;
extern double  Lot_1=0.1;
extern double  LotExp=2.00;
extern int     SL=20;
extern int     TP=30;

extern int     JRSX_Period=7;
extern int     JRSX_Timeframe=60;
extern bool    Use_Conservative_JRSX=false;

int            magicB=7300;
int            magicS=7301;
int            slippage=5;


int            jrsx_OrderType=0;
int            level_curr=1;
int            Open_curr=0;
int            Pending_curr=0;
bool           level_max=false;

int            spread;
double         price_B;  
double         price_S;
double         price_BB;  
double         price_SS;  

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()

{

//----
   double jrsx_curr, jrsx_prev;
           
   Open_curr = Check_Open();
   Pending_curr = Check_Pending();

   jrsx_curr = iCustom(Symbol(),JRSX_Timeframe,"Turbo_JRSX",JRSX_Period,0,1);
   jrsx_prev = iCustom(Symbol(),JRSX_Timeframe,"Turbo_JRSX",JRSX_Period,0,2);
 
   if (Use_Conservative_JRSX==true)
   {            
      if (jrsx_curr > jrsx_prev &&  jrsx_curr > 30 && jrsx_prev < 30) jrsx_OrderType=1;
      if (jrsx_curr < jrsx_prev &&  jrsx_curr < 70 && jrsx_prev > 70) jrsx_OrderType=2;
   }
   if (Use_Conservative_JRSX==false)
   {            
      if (jrsx_curr > jrsx_prev) jrsx_OrderType=1;
      if (jrsx_curr < jrsx_prev) jrsx_OrderType=2;
   }

   Comment ("\n \n current / previous  JRSX  =  ", jrsx_curr, " / ", jrsx_prev,
            "\n open = ", Open_curr, "   pending = ", Pending_curr, "   level = ", level_curr, "   spread = ", spread,
            "\n ", price_B, "   ", price_S, "   ", price_BB, "   ", price_SS);  
      
   
   if(Open_curr==0 && level_max==false) StartTicket();
   
   if(Open_curr!=0 && Pending_curr==0 && level_max==false) Up_Level();

   
//----


   return(0);
}

//+------------------------------------------------------------------+

int StartTicket()
{
   int cmd; double Lots; double stoploss=0; double takeprofit; color colour;

   Clean_Pending();

   RefreshRates();
   price_B=Ask;
   price_S=Bid;
   spread=MarketInfo(Symbol(),MODE_SPREAD);
   price_BB=price_B+(SL-spread)*Point;
   price_SS=price_S-(SL-spread)*Point;

   if(jrsx_OrderType==1) Open_Order_Buy(cmd, Lots, price_B, slippage, stoploss, takeprofit, magicB, colour);
   if(jrsx_OrderType==2) Open_Order_Sell(cmd, Lots, price_S, slippage, stoploss, takeprofit, magicS, colour);
   
   if(jrsx_OrderType==1) Set_Pending_Order_SellStop(cmd, Lots, price_SS, slippage, stoploss, takeprofit, magicS);
   if(jrsx_OrderType==2) Set_Pending_Order_BuyStop(cmd, Lots, price_BB, slippage, stoploss, takeprofit, magicB);

   return(0);   
}
//+------------------------------------------------------

int Up_Level()
{
   int cmd; double Lots; double stoploss=0; double takeprofit; color colour;

   if(Open_curr==1) Set_Pending_Order_SellStop(cmd, Lots, price_SS, slippage, stoploss, takeprofit, magicS);
   if(Open_curr==2) Set_Pending_Order_BuyStop(cmd, Lots, price_BB, slippage, stoploss, takeprofit, magicB);

   return(0);   
}
//+------------------------------------------------------

int Check_Open()
{
   int i;

   if(levels>20) levels=20;
   
   Open_curr=0;

   RefreshRates();
   spread=MarketInfo(Symbol(),MODE_SPREAD);
 
   for(i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if((OrderSymbol()==Symbol() && OrderMagicNumber()==magicB && OrderType() == 0) || (OrderSymbol()==Symbol() && OrderMagicNumber()==magicS && OrderType() == 1))
      {
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels)))    level_curr = levels+1;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-1)))  level_curr = levels  ;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-2)))  level_curr = levels-1;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-3)))  level_curr = levels-2;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-4)))  level_curr = levels-3;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-5)))  level_curr = levels-4;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-6)))  level_curr = levels-5;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-7)))  level_curr = levels-6;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-8)))  level_curr = levels-7;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-9)))  level_curr = levels-8;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-10))) level_curr = levels-9;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-11))) level_curr = levels-10;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-12))) level_curr = levels-11;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-13))) level_curr = levels-12;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-14))) level_curr = levels-13;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-15))) level_curr = levels-14;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-16))) level_curr = levels-15;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-17))) level_curr = levels-16;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-18))) level_curr = levels-17;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-19))) level_curr = levels-18;
         if(OrderLots()==Lot_1*MathRound(MathPow(LotExp,levels-20))) level_curr = levels-19;
         
         if(level_curr>=levels) level_max = true;
         else level_max = false;
         
         if(level_curr==0) level_curr = 1;
         if(OrderType()==0) Open_curr = 1;
         if(OrderType()==1) Open_curr = 2; 

         if(MathMod(level_curr,2)==0 && Open_curr==1)
         {
            price_B=OrderOpenPrice();
            price_S=OrderOpenPrice()-spread*Point;
            price_BB=price_B+(SL-spread)*Point;
            price_SS=price_S-(SL-spread)*Point;
         }
         if(MathMod(level_curr,2)==0 && Open_curr==2)
         {
            price_S=OrderOpenPrice();
            price_B=OrderOpenPrice()+spread*Point;
            price_BB=price_B+(SL-spread)*Point;
            price_SS=price_S-(SL-spread)*Point;
         }
         if(MathMod(level_curr,2)!=0 && Open_curr==1)
         {
            price_B=OrderOpenPrice();
            price_S=OrderOpenPrice()-spread*Point;
            price_BB=price_B+(SL-spread)*Point;
            price_SS=price_S-(SL-spread)*Point;
         }
         if(MathMod(level_curr,2)!=0 && Open_curr==2)
         {
            price_S=OrderOpenPrice();
            price_B=OrderOpenPrice()+spread*Point;
            price_BB=price_B+(SL-spread)*Point;
            price_SS=price_S-(SL-spread)*Point;
         }
      }
   }
   
   return(Open_curr);
}   
//+------------------------------------------------------

int Check_Pending()
{
   int i;

   Pending_curr=0;
 
   for(i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if((OrderSymbol()==Symbol() && OrderMagicNumber()==magicB && OrderType() == 4) || (OrderSymbol()==Symbol() && OrderMagicNumber()==magicS && OrderType() == 5))
      {
         if(OrderType()==4) Pending_curr = 11; 
         if(OrderType()==5) Pending_curr = 22; 
      }
   }
   
   return(Pending_curr);
}   
//+------------------------------------------------------

int Open_Order_Buy(int cmd, double Lots, double price_B, int slippage, double stoploss, double takeprofit, int magicB, color colour)
{
   int ticket;

   while(ticket==0) 
   {
      stoploss = price_B - SL*Point;
      takeprofit = price_B + TP*Point;
      while(IsTradeAllowed() == false) Sleep(6000);
      ticket = OrderSend(Symbol(),0,Lot_1,price_B,slippage,stoploss,takeprofit,NULL,magicB,0,Green);
      if(ticket < 0) ticket = 0;
   }
   
   return(0);
}

//+-------------------------------------------------------

int Open_Order_Sell(int cmd, double Lots, double price_S, int slippage, double stoploss, double takeprofit, int magicS, color colour)
{
   int ticket;
   
   while(ticket==0) 
   {
      stoploss = price_S + SL*Point;
      takeprofit = price_S - TP*Point;
      while(IsTradeAllowed() == false) Sleep(6000);
      ticket = OrderSend(Symbol(),1,Lot_1,price_S,slippage,stoploss,takeprofit,NULL,magicS,0,Red);
      if(ticket < 0) ticket = 0;
   }

   return(0);
}

//+------------------------------------------------------------------+

void Clean_Pending()
{  
   for(int i=0;i<OrdersTotal();i++)
   { 
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if((OrderSymbol()==Symbol() && OrderMagicNumber()==magicB && OrderType() == 4) || (OrderSymbol()==Symbol() && OrderMagicNumber()==magicS && OrderType() == 5))
      {
         int ticket = OrderTicket();
         while(IsTradeAllowed() == false) Sleep(6000);
         OrderDelete(ticket,CLR_NONE);
      }
   }   
}

//+-----------------------------------------------------

int Set_Pending_Order_BuyStop(int cmd, double Lots, double price_BB, int slippage, double stoploss, double takeprofit, int magicB)
{
   int ticket;
   
   while(ticket==0) 
   {
      stoploss = price_BB - SL*Point;
      takeprofit = price_BB + TP*Point;
      while(IsTradeAllowed() == false) Sleep(6000);
      ticket = OrderSend(Symbol(),4,Lot_1*MathRound(MathPow(LotExp,level_curr)),price_BB,slippage,stoploss,takeprofit,NULL,magicB,0,CLR_NONE);
      if(ticket < 0) ticket = 0;
   }
   
   return(0);
}

//+------------------------------------------------------------------+

int Set_Pending_Order_SellStop(int cmd, double Lots, double price_SS, int slippage, double stoploss, double takeprofit, int magicS)
{
   int ticket;
   
   while(ticket==0) 
   {
      stoploss = price_SS + SL*Point;
      takeprofit = price_SS - TP*Point;
      while(IsTradeAllowed() == false) Sleep(6000);
      ticket = OrderSend(Symbol(),5,Lot_1*MathRound(MathPow(LotExp,level_curr)),price_SS,slippage,stoploss,takeprofit,NULL,magicS,0,CLR_NONE);
      if(ticket < 0) ticket = 0;
   }

   return(0);
}

//+------------------------------------------------------------------+


